#!/usr/local/bin/perl
# setup - script to write forms to add or delete files from a shared directory
#  called from the shared-dir/homepage.html
#  The user must have add permission to load a file and delete permission to
#  delete a file. 
#  The output form sets up calls to delete.cgi and storefile.cgi

$URLbasedir= "/home/T11F/webflow/Akenti/akenti-docs";
unshift(@INC,"$URLbasedir/cgi-bin");
require 'definitions.pl';
require "fwwwhttp.pl";


if ($ENV{'REQUEST_METHOD'} eq 'GET')  {
    $buffer = $ENV{'QUERY_STRING'};
} else {
    read (STDIN, $buffer, $ENV{CONTENT_LENGTH});
}

system(umask 2);
$verbose = 1;

print "content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>setup shared files</TITLE></HEAD>\n<BODY BGCOLOR=#ffffff >\n";
if ($verbose) {
    print "Debugging output for shared-setup\n";
}
$priv = $ENV{PRIVILEGE};
$dn = $ENV{SSL_CLIENT_DN};
if ($verbose) {print "$dn<br> has rights: $priv<br>\n";}

@pairs = split (/&/,$buffer);
#translate special HTTP chars back to plain ascii
$NC=0; 
foreach $pair (@pairs) {
    $pair =~ tr/+/ /;
    $pair =~ s/%0[Dd]//g;  #dump the CR's
    $pair =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
    ($name,$value) = split(/=/,$pair);
    if ($name eq "dir_name") { $dir_name=$value;}
    elsif ($name eq "action") { 
	if ($value eq "Load file") {$action="load";}
	elsif ($value eq "Delete selected files" ) { $action="delete";}
    }
    elsif ($name eq "delete_file") {push(@del_file, $value);}
}

if  ($action eq "load"){
    if (!($priv =~ /add/)){
	&report_status("Permission Denied", "setup", "You do not have add permission in directory $dir_name");
    exit;
    }

    $a =<<TEXT;

<H1>LBNL Image Library  --  Upload a file</H1>

<HR>
<FORM ENCTYPE="multipart/form-data" METHOD="POST" ACTION="/$dir_name/storefile.cgi">
<B>
Destination directory name <INPUT TEXT NAME="dir_name" VALUE="$dir_name" SIZE=35><br>
Destination file name <INPUT TEXT NAME="file_name" SIZE=35><br><br>
Enter any comments about this file:<br>
<TEXTAREA NAME="comments", rows=3, cols=50> </TEXTAREA><br>
Path name of source file: <INPUT NAME="userfile", TYPE="file"><br>
</B>

<INPUT TYPE="SUBMIT" VALUE="send_file">

</BODY>
TEXT
    print $a;
}
elsif ($action eq "delete") {
    if (!($priv =~ /delete/)){
	&report_status("Permission Denied", "setup", "You do not have delete permission in directory $dir_name");
    exit;
    }

    $a = <<TEXT;
<H1>LBNL Image Library  --  Delete a file</H1>
<FORM METHOD=GET ACTION="/$dir_name/delete.cgi">
<INPUT TYPE=HIDDEN NAME=dir_name VALUE=$dir_name>
<h2>Do you really want to delete the following file(s) from $dir_name</h2>
TEXT
    print $a;
    foreach $file (@del_file) {
	print "$file<BR>\n";
	print "<INPUT TYPE=HIDDEN NAME=delete_file VALUE=$file><BR>\n";
    }
    print "<INPUT TYPE=SUBMIT NAME=action VALUE=DELETE><BR>";
    print "</FORM>";
    print "<a href=\"/$dir_name\"><B>Go Back</b></a><br>\n";
    print "</BODY></HTML>\n";

    }
else {
    &report_status("Error", "setup", "Unknown action $action");
}



